<?php 

$proxyhost = "localhost";
$proxyport = "8081";

$proxyhostssl = "localhost";
$proxyportssl = "8444";

$hmac_key = "ohnae3Ie";

$dst_serialized = $_REQUEST['DST'];
$dst_sign = $_REQUEST['DST_SIGN'];
$calculated_dst_sign = hash_hmac("md5", $dst_serialized, $hmac_key);
if ($dst_sign != $calculated_dst_sign) {
	die("tpl2http.php: signature mismatch");
}
$dst = unserialize($dst_serialized);

$ssl = $dst['ssl'];
$request_line = $dst['request_line'];
$headers = $dst['headers'];
$body = $dst['tpl_body'];

foreach($_REQUEST as $key => $val) {
	if (preg_match('/^BODYTPLVAR_(.)_(.*)$/', $key, $matches)) {
		if ($matches[1] == "Q") {
			# quote string
			$val = '"' . addcslashes($val, '"') . '"';
		} else if ($matches[1] == "_") {
			# do nothing
		} else {
			die("malformed tpl var name '$key'");
		}

                $tpl_var = '"{' . $matches[1] . '_' . $matches[2] . '}"';
		$body = preg_replace("/$tpl_var/", $val, $body);

                $tpl_var_escaped = urlencode($tpl_var);
		$val_escaped = urlencode($val);
		$body = preg_replace("/$tpl_var_escaped/", $val_escaped, $body);
	}
}

#var_dump($dst);
#var_dump($request_line);
#var_dump($headers);
#var_dump($body);

if ($ssl) {
	$host = "ssl://$proxyhost";
	$port = $proxyportssl;
} else {
	$host = $proxyhostssl;
	$port = $proxyport;
}

#echo "*** Connecting to $host:$port ***<br/>";

$fp = fsockopen($host, $port, $errno, $errstr);
if (!$fp) {
	die("fsockopen('$host:$port'): $errstr");
}

fwrite($fp, "$request_line\r\n");
foreach($headers as $header_name => $header_value) {
	if (strcasecmp($header_name, "content-length") == 0) {
		fwrite($fp, "Content-Length: " . strlen($body) . "\r\n");
	} else {
		fwrite($fp, "$header_name: $header_value\r\n");
	}
}
fwrite($fp, "\r\n");
fwrite($fp, $body);
fflush($fp);

#while (!feof($fp)) {
#	print(fread($fp, 1024));
#}
#die();

$in_header = true;

while (($buffer = fgets($fp, 4096)) !== false) {
	if ($in_header) {
		$chomped_buffer = rtrim($buffer, "\r\n");
		if (strlen($chomped_buffer) > 0) {
			$is_setcookie = preg_match("/^set-cookie:/i", $chomped_buffer) > 0;
			# don't replace set-cookie headers, append them
			header($chomped_buffer, !$is_setcookie);
		} else {
			$in_header = false;
			#echo "\r\n";
		}
	} else {
		echo $buffer;
	}
}

#var_dump(headers_sent());

fclose($fp);
?>
